module Engine.IrulanRTError
( mkIrulanRTErrorExpr
, recoverIrulanRTError
, IrulanRTError(..)
) where

import Control.Exception
import Data.List
import Control.Monad
import MkId (eRROR_ID)
import HscTypes
import MkCore
import Type
import CoreSyn
import Bottom

data IrulanRTError 
  = Bottom BottomId
  deriving (Read, Show)

recoverIrulanRTError :: SomeException -> Maybe IrulanRTError
recoverIrulanRTError se = do
  ErrorCall s <- fromException se
  guard (irulanPrefix `isPrefixOf` s)
  let rest = drop (length irulanPrefix) s
  [(ret, "")] <- return $ reads rest
  return ret

irulanPrefix :: String
irulanPrefix = "__$irulan:"

mkIrulanRTErrorExpr :: (MonadThings m) => Type -> IrulanRTError -> m CoreExpr
mkIrulanRTErrorExpr t e = do
  stringExpr <- mkStringExpr $ irulanPrefix ++ show e
  return $ mkCoreApps (Var eRROR_ID) [Type t, stringExpr]
