{-# LANGUAGE TypeOperators #-}
{- I WANT Data.Record.Label
 -
 - Design & Interface inspired by fclabels by
 - Sebastiaan Visser, Erik Hesselink, Chris Eidhof, Sjoerd Visscher.
 - http://hackage.haskell.org/package/fclabels
 -}
module Util.FCLabels
( (:->)
, get
, set
, mod
, label
, mkLabels
) where

import Control.Category
import Prelude hiding ((.), mod, id)
import Util.FCLabels.TH

data a :-> b = FCL { get :: a -> b
                   , set :: b -> a -> a
                   }


instance Category (:->) where
  id = FCL { get = id
           , set = const
           }

  fcl1 . fcl2 = FCL { get = get fcl1 . get fcl2
                    , set = mod fcl2 . set fcl1 
                    }

mod :: (a :-> b) -> (b -> b) -> a -> a
mod fcl f a = set fcl (f $ get fcl a) a

label :: (a -> b) -> (b -> a -> a) -> a :-> b
label = FCL
